% Toate numerele prime mai mici ca 100.

% e_prim(+X)
e_prim(X):-
    \+ (X1 is floor(X / 2), between(2, X1, N), 0 =:= X mod N).

% prime(+N, ?L)
prime(N, L):-
    findall(X, (between(2, N, X), e_prim(X)), L).

% Toți divizorii primi ai unor numere.

divizori(L, D):-
    setof(X, N^(member(N, L), between(2, N, X), 0 =:= N mod X, e_prim(X)), D).

% Exemplu cu bagof/3

p(a,1).
p(a,2).
p(b,3).
p(c,4).
p(c,5).
p(c,6).

p:- bagof(X, p(_,X), L), format('~w~n',[L]), fail.

q:- bagof(X, Z^p(Z,X), L), format('~w~n',[L]), fail.